[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

Re: Problem with 2.3.1-8 for hppa



At Sat, 4 Jan 2003 19:24:58 +0100,
Martin Schulze wrote:
> I guess this is a glibc problem, but I'm not 100% sure, of course.
> 
> paer!joey(pts/9):/tmp# apt-get update
> E: Could not get lock /var/lib/apt/lists/lock - open (22 Invalid argument)
> E: Unable to lock the list directory
> paer!joey(pts/9):/tmp# l -d /var/lib/apt/lists/lock
> 
> I've updated glibc to the version in the subject line.  This one doesn't
> complain about a too old kernel at least.
> 
> Also, entering the unstable chroot on the regular basis results in:
> 
> paer!joey(pts/9):~> dchroot unstable
> Executing shell in chroot: /org/paer.debian.org/chroot/unstable
> paer!I have no name!(pts/9):~>
> 
> So libnss doesn't work as expected anymore.

	paer:~> uname -a
	Linux paer 2.4.18-64 #1 Sat Mar 30 19:15:51 MST 2002 parisc64 unknown unknown GNU/Linux

It's parisc64 and kernel 2.4.18.  I found Randolph's mail:

At Sun, 8 Dec 2002 22:08:33 -0800,
Randolph Chung wrote:
> This is a heads up for people running 64-bit hppa kernels with new glibc
> (2.3.1). Make sure you have at least 2.4.19-pa17, otherwise fcntl() will
> break with the new glibc and you won't be able to use e.g. apt.
> 
> This was needed to fix some problems with lfs on hppa. Unfortunately it
> cannot be done in a completely backwards compatible manner.
> 
> 32-bit kernels are not affected.
> 
> <sigh>

Currently, libc6 preinst blocks 2.4.16 and older kernel:

    # HPPA boxes require latest fixes in the kernel to function properly.
    if [ "$realarch" = parisc64 ] || [ "$realarch" = parisc ]
    then
        kernel_ver=`uname -r`
        if dpkg --compare-versions "$kernel_ver" lt 2.4.17
        then
                echo WARNING: This version of libc6 requires that you be running
                echo atleast a 2.4.17 kernel in order to work properly. Earlier
                echo kernels did not provide the proper functionality in order 
                echo for the system to be stable. 
                exit 1
        fi
    fi

So fixing either glibc or libc6 preinst is needed.  From Randolph's mail, 
comparing kernel version with 2.4.19-pa17 in libc6 preinst is needed.
I've added changes for the current glibc cvs as follows:

--- debian/libc/DEBIAN/preinst 18 Dec 2002 14:51:18 -0000      1.3
+++ debian/libc/DEBIAN/preinst 5 Jan 2003 01:36:40 -0000
@@ -101,7 +101,7 @@
        fi
     fi
     # HPPA boxes require latest fixes in the kernel to function properly.
-    if [ "$realarch" = parisc64 ] || [ "$realarch" = parisc ]
+    if [ "$realarch" = parisc ]
     then
        kernel_ver=`uname -r`
        if dpkg --compare-versions "$kernel_ver" lt 2.4.17
@@ -110,6 +110,19 @@
                echo atleast a 2.4.17 kernel in order to work properly. Earlier
                echo kernels did not provide the proper functionality in order 
                echo for the system to be stable. 
+               exit 1
+       fi
+    fi
+    # parisc64 boxes require latest fixes in the kernel to function properly.
+    if [ "$realarch" = parisc64 ]
+    then
+       kernel_ver=`uname -r`
+       if dpkg --compare-versions "$kernel_ver" lt 2.4.19-pa17
+       then
+               echo WARNING: This version of libc6 requires that you be running
+               echo atleast a 2.4.19-pa17 kernel in order to work properly.
+               echo Earlier kernels did not provide the proper functionality
+               echo in order for the system to be stable. 
                exit 1
        fi
     fi

Randorph, Carlos, could you tell me is this OK?

Regards,
-- gotom



Reply to: